<template>
  <div class="shop">
    <b-navbar toggleable="lg" type="dark" variant="info" sticky>
      <b-navbar-brand href="/">SIGSHOP</b-navbar-brand>
      <b-navbar-nav class="ml-auto">
        <span class="d-flex align-items-center text-white">Categoría:</span>
        <b-form-select
          v-model="selected"
          :options="categories"
          text-field="name"
          value-field="id"
          class="mx-3"
        >
          <template v-slot:first>
            <option :value="null" disabled>-- Selecciona una opción --</option>
          </template>
        </b-form-select>
        <v-dialog v-model="dialog" persistent max-width="900px">
          <template v-slot:activator="{ on: dialog }">
            <v-tooltip bottom>
              <template v-slot:activator="{ on: tooltip }">
                <v-btn text v-on="{...tooltip, ...dialog}" class="body-1">
                  <v-icon>mdi-cart</v-icon>
                  {{cart_amount}}
                </v-btn>
              </template>
              <span>Ver Carrito</span>
            </v-tooltip>
          </template>
          <v-card>
            <v-card-title class="headline grey lighten-2">
              <v-icon class="mr-2">mdi-cart</v-icon>Carrito
              <v-divider vertical></v-divider>
              <span v-if="cart_amount" class="ml-auto">Total: $ {{cart_total}}</span>
            </v-card-title>
            <v-card-text
              v-if="!cart_amount"
              style="height: 400px"
              class="d-flex align-items-center justify-content-center"
            >Agrega productos para empezar a comprar</v-card-text>
            <v-card-text v-else>
              <v-simple-table fixed-header height="400px">
                <template v-slot:default>
                  <thead>
                    <tr>
                      <th class="text-center">Imagen</th>
                      <th class="text-center">Producto</th>
                      <th class="text-center">Precio</th>
                      <th class="text-center">Cantidad</th>
                      <th class="text-center">Total</th>
                      <th></th>
                    </tr>
                  </thead>
                  <tbody>
                    <tr v-for="product in cart_products" :key="product.id">
                      <td>
                        <v-img :src="product.thumbnail" max-width="90" max-height="90"></v-img>
                      </td>
                      <td>{{ product.title }}</td>
                      <td style="width: 100px;">$ {{ product.price }}</td>
                      <td>
                        <v-text-field
                          style="width: 100px;"
                          type="number"
                          v-model="product.amount"
                          :min="1"
                          @click="calculateTotal(product.id)"
                        ></v-text-field>
                      </td>
                      <td style="width: 100px;">$ {{ product.total }}</td>
                      <td>
                        <v-tooltip bottom>
                          <template v-slot:activator="{ on }">
                            <v-btn class="ma-2" text icon v-on="on" @click="updateCart(product)">
                              <v-icon>mdi-trash-can</v-icon>
                            </v-btn>
                          </template>
                          <span>Quitar</span>
                        </v-tooltip>
                      </td>
                    </tr>
                  </tbody>
                </template>
              </v-simple-table>
            </v-card-text>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="green darken-1" v-if="cart_amount" text @click="payment">Pagar</v-btn>
              <v-btn color="red darken-1" text @click="closeDialog">Cancelar</v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
        <v-tooltip bottom>
          <template v-slot:activator="{ on }">
            <v-btn text icon v-on="on" @click="logout">
              <v-icon v-on="on">mdi-exit-to-app</v-icon>
            </v-btn>
          </template>
          <span>Cerrar Sesión</span>
        </v-tooltip>
      </b-navbar-nav>
    </b-navbar>
    <b-alert
      class="m-0 shadow"
      :show="dismissCountDown"
      dismissible
      variant="success"
      @dismissed="dismissCountDown=0"
      @dismiss-count-down="countDownChanged"
    >Pago Realizado, Gracias por comprar!</b-alert>
    <Home v-if="!selected" />
    <div class="d-flex flex-row flex-wrap justify-content-between grey lighten-2" v-else>
      <div v-for="product in products" :key="product.id">
        <b-card
          :title="product.title"
          :img-src="product.thumbnail"
          img-alt="Image"
          img-top
          tag="article"
          style="max-width: 15rem; min-width: 15rem;"
          class="m-4 pt-2 shadow-sm"
        >
          <b-card-text>$ {{ product.price }}</b-card-text>
          <b-button @click="addToCart(product)" variant="primary">
            <v-icon dark>mdi-cart-plus</v-icon>
          </b-button>
        </b-card>
      </div>
    </div>
  </div>
</template>

<script>
import Home from "../components/Home.vue";
import { mapActions, mapState } from "vuex";

export default {
  components: {
    Home
  },
  data() {
    return {
      dialog: false,
      selected: null,
      categories: [],
      products: [],
      cart_products: [],
      dismissSecs: 3,
      dismissCountDown: 0
    };
  },
  created() {
    this.getCategories();
  },
  watch: {
    selected: function() {
      this.getProducts();
    }
  },
  computed: {
    ...mapState(["token"]),
    cart_amount: function() {
      return this.cart_products.length;
    },
    cart_total: function() {
      if (this.cart_amount > 1) {
        const total = this.cart_products
          .reduce((a, b) => {
            return parseFloat(a) + parseFloat(b.total);
          }, 0)
          .toFixed(2);
        return total;
      } else {
        return this.cart_products[0].total;
      }
    }
  },
  methods: {
    ...mapActions(["logout"]),
    getCategories() {
      let config = {
        headers: {
          token: this.token
        }
      };
      this.axios
        .get("/categories/all", config)
        .then(res => {
          this.categories = res.data;
        })
        .catch(e => {
          console.log(e.response);
        });
    },
    getProducts() {
      let config = {
        headers: {
          token: this.token
        }
      };
      this.axios
        .get(`/products/all/${this.selected}`, config)
        .then(res => {
          this.products = res.data.results;
        })
        .catch(e => {
          console.log(e.response);
        });
    },
    addToCart(product) {
      this.cart_products.push({
        id: product.id,
        title: product.title,
        price: product.price,
        amount: 1,
        total: product.price,
        thumbnail: product.thumbnail
      });
      const filteredItems = this.products.filter(
        item => item.id !== product.id
      );
      this.products = filteredItems;
    },
    calculateTotal(product_id) {
      const index = this.cart_products.findIndex(
        product => product.id == product_id
      );
      this.cart_products[index].total = (
        parseFloat(this.cart_products[index].price) *
        this.cart_products[index].amount
      ).toFixed(2);
    },
    updateCart(product) {
      const filteredItems = this.cart_products.filter(
        item => item.id !== product.id
      );
      this.cart_products = filteredItems;
      const verification = this.products
        .map(p => {
          return p.id;
        })
        .indexOf(product.id);
      if (verification === -1) {
        this.products.unshift(product);
      }
    },
    payment() {
      this.closeDialog();
      this.showAlert();
      this.cart_products = [];
      this.selected = null;
    },
    closeDialog() {
      this.dialog = false;
    },
    countDownChanged(dismissCountDown) {
      this.dismissCountDown = dismissCountDown;
    },
    showAlert() {
      this.dismissCountDown = this.dismissSecs;
    }
  }
};
</script>

<style>
.shop {
  height: 100%;
}
.navbar {
  max-height: 50px;
}
.card-title {
  font-size: 14px;
}
.card img {
  max-width: 100px;
  align-self: center;
}
</style>
